#!/usr/bin/perl -w

#   Author: Paul Fitzpatrick, paulfitz@ai.mit.edu
#   Copyright (c) 2003 Paul Fitzpatrick
#
#   This file is part of CosmicOS.
#
#   CosmicOS is free software; you can redistribute it and/or modify
#   it under the terms of the GNU General Public License as published by
#   the Free Software Foundation; either version 2 of the License, or
#   (at your option) any later version.
#
#   CosmicOS is distributed in the hope that it will be useful,
#   but WITHOUT ANY WARRANTY; without even the implied warranty of
#   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#   GNU General Public License for more details.
#
#   You should have received a copy of the GNU General Public License
#   along with CosmicOS; if not, write to the Free Software
#   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

use strict;

sub EvalBinary {
  my $txt = shift;
  $txt =~ s/[^\.\:]//g;
  $txt =~ s/\:/1/g;
  $txt =~ s/\./0/g;
  $txt = "0b$txt";
  #print "EVALUATE ", $txt, " AS ", oct($txt), "\n";
  return oct($txt);
};

print "(load \"fritz\")\n";

while (<>)
  {
    chomp;
    if ($_ =~ /([^\#]*)((\#.*)?)/)
      {
	my $body = $1;
	my $comment = $2;
	my $lisp = $body;
	while ($lisp =~ /(\(([\:\.]+)\))/)
	  {
	    my $all = $1;
	    my $num = $2;
	    my $val = EvalBinary($2);
	    $all = quotemeta($all);
	    $lisp =~ s/$all/ $val /g;
	  }
	#$lisp =~ s/\(\:\)/ 1 /g;
	#$lisp =~ s/\(\.\)/ 0 /g;
	$lisp =~ s/\;//g;
	if ($lisp =~ /[^ \t]/)
	  {
	    $lisp = "(fritz-translate-show '$lisp)";
	    #$lisp = "(fritz-eval-show '$lisp)";
	  }
	$comment =~ s/^\#/\;/;
	if ($comment =~ /\;/)
	  {
	    $comment = "(begin (display \"$comment\") (display \"\\n\"))\n";
	  }
	print "$lisp$comment\n";
      }
  }

