#!/usr/bin/perl -w

#   Author: Paul Fitzpatrick, paulfitz@ai.mit.edu
#   Copyright (c) 2003 Paul Fitzpatrick
#
#   This file is part of CosmicOS.
#
#   CosmicOS is free software; you can redistribute it and/or modify
#   it under the terms of the GNU General Public License as published by
#   the Free Software Foundation; either version 2 of the License, or
#   (at your option) any later version.
#
#   CosmicOS is distributed in the hope that it will be useful,
#   but WITHOUT ANY WARRANTY; without even the implied warranty of
#   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#   GNU General Public License for more details.
#
#   You should have received a copy of the GNU General Public License
#   along with CosmicOS; if not, write to the Free Software
#   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

use strict;

my $txt = "";

my %id;
$id{"?"} = 0;
$id{"+"} = 1;
$id{"*"} = 2;
$id{"-"} = 3;
$id{"/"} = 4;
$id{"="} = 5;
$id{"not"} = 6;
$id{"intro"} = 7;
$id{"unary"} = 8;
$id{"<="} = 9;
$id{">="} = 10;
$id{"<"} = 11;
$id{">"} = 12;
$id{"and"} = 13;
$id{"or"} = 14;
$id{"false"} = 15;
$id{"true"} = 16;
$id{"define"} = 17;
$id{"if"} = 18;
$id{"forall"} = 19;
$id{"exists"} = 20;
$id{"cons"} = 21;
$id{"car"} = 22;
$id{"cdr"} = 23;
$id{"number?"} = 24;
$id{"translate"} = 25;
$id{"lambda"} = 26;
$id{"make-cell"} = 27;
$id{"set!"} = 28;
$id{"get!"} = 29;
$id{"all"} = 30;
$id{"natural-set"} = 31;
$id{"undefined"} = 32;

my $free_id = 33;


while (<>)
  {
    chomp;
    if ($_ =~ /([^\#]*)((\#.*)?)/)
      {
	my $body = " $1 ";
	my $comment = $2;
	while ($body =~ /(([ \t\(\)])([a-zA-Z\!\?\+\*\-\/\_\>\<\=][a-zA-Z\!\?\+\*\-\/\_\>\<\=0-9]*)([ \t\(\)]))/)
	  {
	    my $context = $1;
	    my $left = $2;
	    my $term = $3;
	    my $right = $4;
	    if (!defined($id{$term}))
	      {
		$id{$term} = $free_id;
		$free_id++;
	      }
	    my $num = $id{$term};
	    $term = quotemeta($context);
	    $body =~ s/$term/$left$num$right/g;
	  }
	$body =~ s/^ //;
	$body =~ s/ $//;
	print "$body$comment\n";
      }
  }

